<?php

namespace Modules\Sc\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Hr\Entities\Employee;
use Modules\Hr\Entities\EmployeeDepartment;
use Modules\Pd\Entities\ScheduleCustomerOrderPlan;
use Modules\PJ\Entities\Project;
use Modules\Pp\Entities\CustomerPlan;
use Modules\Pp\Entities\Machinary;
use Modules\Sc\Entities\Department;
use Modules\Sc\Entities\GrnData;
use Modules\Sc\Entities\GrnHeader;
use Modules\Sc\Entities\MaterialRequisitionData;
use Modules\Sc\Entities\MiData;
use Modules\Sc\Entities\MiHeader;
use Modules\Sc\Entities\ProductHistory;
use Modules\Sc\Entities\ProductHistorySetoff;
use Modules\Sc\Entities\StoreLocation;
use Modules\St\Entities\Product;
use Modules\St\Entities\ProductUnit;
use Modules\St\Entities\Suppliers;
use Modules\St\Entities\Uom;

class MiHeaderControllrController extends Controller
{
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        return view('sc::index');
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('sc::create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        return view('sc::show');
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        return view('sc::edit');
    }



    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        //
    }

    public function allEmployees()
    {
        try {
            $employees = Employee::all();
            $result = array();
            foreach ($employees as $emp) {
                array_push($result, [
                    "img" => "",
                    "id" => $emp->employee_id,
                    "value" => $emp->name_withinitial,
                ]);
            }
            $responseBody = $this->responseBody(true, "MiHeaderController", "allEmployees", $result);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    public function allProjects()
    {
        try {
            $projects = Project::all();
            $responseBody = $this->responseBody(true, "MiHeaderController", "allProjects", $projects);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "GrnReturnController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }




    public function allDepartment()
    {
        try {
            $department =  EmployeeDepartment::all();
            $responseBody = $this->responseBody(true, "MiHeaderController", "allDepartment", $department);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allMachinery()
    {
        try {
            $machinery =  Machinary::all();
            $responseBody = $this->responseBody(true, "MiHeaderController", "allMachinery", $machinery);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allProduct()
    {
        try {
            $products =  Product::select('product_primary_id As id', 'product_id As value0', 'product_name As value1')->get();
            return $this->responseBody(true, "MiHeaderController", "allProduct", $products);
        } catch (Exception $exception) {
            return $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
    }


    public function maxID($store_id)
    {
        try {
            $id = DB::select('SELECT AUTO_INCREMENT  AS id FROM information_schema.TABLES WHERE TABLE_SCHEMA = "erp_riococo_salary3" AND TABLE_NAME = "sc_grn_headers"')[0]->id;
            $store = StoreLocation::find($store_id);
            $prefix = "";
            if ($store) {
                $prefix = $store->prefix;
            }
            $responseBody = $this->responseBody(true, "MiHeaderController", "allProductUnit", ['id' => $id, 'prefix' => $prefix]);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allProductUnit()
    {
        try {
            $products =  ProductUnit::all();
            $responseBody = $this->responseBody(true, "MiHeaderController", "allProductUnit", $products);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }

    public function allStores()
    {
        try {
            $stores =  StoreLocation::all();
            $responseBody = $this->responseBody(true, "MiHeaderController", "allStores", $stores);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allProductCustomer()
    {
        try {
            $query = 'SELECT pp_customer_order_plans.customer_order_plan_id,
            pp_customer_orders.factory_po_num,
            st_products.product_name,
            pp_customer_order_plans_data.customer_order_plan_data_id
            FROM pp_customer_order_plans
            LEFT JOIN pp_customer_orders ON pp_customer_order_plans.order_id = pp_customer_orders.order_id
            LEFT JOIN pp_customer_order_plans_data ON pp_customer_order_plans.customer_order_plan_id = pp_customer_order_plans_data.customer_order_plan_id
            LEFT JOIN st_products ON pp_customer_order_plans_data.product_id = st_products.product_primary_id
			GROUP BY pp_customer_order_plans.customer_order_plan_id ORDER BY pp_customer_order_plans.customer_order_plan_id DESC';
            $orderPlan =  DB::select($query);
            $responseBody = $this->responseBody(true, "MiHeaderController", "allProductCustomer", $orderPlan);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function save(Request $request)
    {
        try {
            $material_request_id = $request->get('mr_internal_id');
            $material_request_data = MaterialRequisitionData::where('internal_id', '=', $material_request_id)->get();
            $mi = new MiHeader();
            $mi->external_id = $request->get('external_id');
            $mi->ref_external_id = $request->get('ref_external_id');
            $mi->trans_date = $request->get('trans_date');
            $mi->dept_id = $request->get('dept_id');
            $mi->machine_id = $request->get('machine_id');
            $mi->store_id = $request->get('store_id');
            $mi->supervisor_id = "0";
            $mi->employee_name = $request->get('employee_name');
            $mi->mr_internal_id = $request->get('mr_internal_id');
            $mi->mr_extenal_id = $request->get('mr_extenal_id');
            $mi->mi_type = $request->get('mi_type');
            $mi->manufacturing_order_number = $request->get('manufacturing_order_number');
            $mi->customer_order_plan_data_id = $request->get('customer_order_plan_data_id');
            $mi->project_code = $request->get('project_code');
            $mi->remarks = $request->get('remarks');
            $mi->vehicle_no = $request->get('vehicle_no');
            $mi->user_id = Auth::user()->id;
            $mi->Status = 0;
            if ($mi->save()) {
                $mi = MiHeader::find($mi->internal_id);
                $mi->ref_internal_id = $mi->internal_id;
                $mi->update();
                $mi_arr = $request->get("mi_data");
                for ($i = 0; $i < count($mi_arr); $i++) {
                    $miData = json_decode($mi_arr[$i]);
                    $mi_data = new MiData();
                    $mi_data->internal_id = $mi->internal_id;
                    $mi_data->external_id = $mi->external_id;
                    $mi_data->product_id =  $miData->product_id;
                    $mi_data->unit_id =  $miData->unit_id;
                    $mi_data->quantity =  $miData->qty;
                    $mi_data->comments =  $miData->comments;
                    if ($mi_data->save()) {

                        /*foreach ($material_request_data as $data) {
                            if ($data->product_id == $miData->product_id) {
                                $mrItem = MaterialRequisitionData::find($data->mr_data_id);
                                if ($mrItem) {
                                    $mrItem->issues_quantity = ($mrItem->issues_quantity + $miData->qty);
                                    $mrItem->update();
                                }
                            }
                        }*/

                        $this->addProductToHistory($mi->internal_id);
                    }
                }
            }
            $responseBody = $this->responseBody(true, "MiHeaderController", "saveGrnHeaderTemp", true);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }






    public function getMaterialIssue($id)
    {
        try {
            $mi = MiHeader::find($id);
            //$supervisor = Employee::find($mi->supervisor_id);
            $received = Employee::find($mi->received_by);
            //$mi->supervisor = $supervisor->name_withinitial;
            $mi_data = MiData::where('internal_id', '=', $id)->get();
            foreach ($mi_data as $data) {
                $product = Product::where('product_primary_id', '=', $data->product_id)->first();
                $data->product = $product->product_name;
                $uom = ProductUnit::find($product->uom_id);
                $uom_arr = [];
                if ($uom) {
                    array_push($uom_arr, ["value" => $uom->id, "text" => $uom->name]);
                }
                $data->uom = $uom_arr;
                $data->product_primary_id = $product->product_primary_id;
                $data->product_id = $product->product_id;
            }
            $mi->data = $mi_data;
            $responseBody = $this->responseBody(true, "MiHeaderController", "getGrn", $mi);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function getQty($product_id, $store_id)
    {
        try {
            $query = "SELECT SUM(quantity) AS quantity FROM sc_product_histories WHERE product_id = '" . $product_id . "' AND store_id = '" . $store_id . "'";
            $result = DB::select($query);
            $quantity = 0;
            foreach ($result as $data) {
                if ($data->quantity) {
                    $quantity = $data->quantity;
                }
            }
            $responseBody = $this->responseBody(true, "MiHeaderController", "getQty", $quantity);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function update(Request $request, $id)
    {

        try {
            $mi_header = MiHeader::find($id);
            if ($mi_header) {
                if ($this->delete($mi_header->external_id)) {
                    $this->removeProductHistory($mi_header);
                    $this->removeProductFromSetoff($mi_header);
                    if ($mi_header->delete()) {
                        $bool =  $this->save($request);
                    }
                }
            }
            $responseBody = $this->responseBody(true, "MiHeaderController", "saveGrnHeaderTemp", $bool);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function deleteMaterialIssue($id)
    {

        try {
            $mi_header = MiHeader::find($id);
            if ($mi_header) {
                if ($this->delete($mi_header->external_id)) {
                    $this->removeProductHistory($mi_header);
                    $this->removeProductFromSetoff($mi_header);
                    $mi_header->delete();
                }
            }
            $responseBody = $this->responseBody(true, "MiHeaderController", "deleteMaterialIssue", true);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "deleteMaterialIssue", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function delete($id)
    {
        try {
            $mi_data = MiData::where('external_id', '=', $id)->delete();
            $responseBody = $this->responseBody(true, "MiHeaderController", "delete", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    private function addReturnToSetoff($internal_id, $external_id, $ref_internal_id, $ref_external_id, $product_id, $quantity, $store_id, $transaction_id)
    {


        //$product_history = ProductHistory::where([['internal_id', '=', $ref_internal_id], ['product_id', '=', $product_id], ['store_id', '=', $store_id]])->first();

        $setoff = new ProductHistorySetoff();
        $setoff->internal_id = $internal_id;
        $setoff->external_id = $external_id;
        $setoff->ref_internal_id = $ref_internal_id;
        $setoff->ref_external_id = $ref_external_id;
        $setoff->document_no = '200';
        $setoff->product_history_transaction_id = $transaction_id;
        $setoff->product_id = $product_id;
        $setoff->setoff_quantity = 0;
        $setoff->quantity = ($quantity * -1);
        $setoff->cost_price = 0;
        $setoff->store_id = $store_id;
        $setoff->user_id = Auth::user()->id;
        if ($setoff->save()) {
            //$this->updateProductHistorySetOff($setoff->ref_internal_id, $setoff->product_id, $setoff->store_id, $quantity);
        }
    }



    private function updateProductHistorySetOff($ref_internal_id, $product_id, $store_id, $setoff_quantity)
    {

        $product_history = ProductHistory::where([['product_id', '=', $product_id], ['store_id', '=', $store_id], ['document_no', '=', '100']])->get();

        $setoff = $setoff_quantity;

        foreach ($product_history as $data) {
            $setoff += $data->set_off;
            if ($setoff >= $data->quantity) {
                $data->set_off = $data->quantity;
                $data->update();
                $setoff = ($setoff - $data->quantity);
            } else {
                $data->set_off = $setoff;
                $data->update();
                $setoff = ($setoff - $setoff_quantity);
            }
        }
    }



    public function approve($id)
    {

        try {

            $mi_header = MiHeader::find($id);
            if ($mi_header->status == 0) {
                $mi_header->status = 1;
                $msg = '<i class="fa fa-check" aria-hidden="true"></i>';
                $mi_header->update();
                //$this->addProductToSetoff($id);
            } else if ($mi_header->status == 1) {
                $mi_header->status = 0;
                $msg = '<i class="fa fa-times" aria-hidden="true"></i>';
                $mi_header->update();
                //$this->removeProductFromSetoff($id);
            }

            $responseBody = $this->responseBody(true, "MiHeaderController", "approve", $msg);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }





    private function addProductToHistory($id)
    {
        $query = "SELECT sc_mi_headers.store_id,sc_mi_data.*FROM sc_mi_data INNER JOIN sc_mi_headers
        ON sc_mi_data.internal_id = sc_mi_headers.internal_id WHERE sc_mi_data.internal_id = '" . $id . "'";

        $result = DB::select($query);
        //ProductHistory::where([['internal_id', '=', $id], ['document_no', '=', '200']])->delete();


        foreach ($result as $data) {
            $product_history = new ProductHistory();
            $product_history->internal_id = $data->internal_id;
            $product_history->external_id = $data->external_id;
            $product_history->document_no = 200;
            $product_history->description = "Material Issue";
            $product_history->product_id = $data->product_id;
            $product_history->unit_id = $data->unit_id;
            $product_history->quantity = ($data->quantity * -1);
            $product_history->set_off = 0;
            $product_history->cost_price = 0;
            $product_history->store_id = $data->store_id;
            $product_history->user_id = Auth::user()->id;

            //$grn_product_history = ProductHistory::where([['product_id', '=', $data->product_id], ['store_id', '=', $data->store_id], ['document_no', '=', '100']])->get();

            if ($product_history->save()) {
                $product_history_setoff = new ProductHistorySetOffController();
                $product_history_setoff->saveMaterialIssue($product_history, $data->store_id);
            }

            /*$request_qty = 0;
            foreach ($grn_product_history as $grn_prd) {
                $qty = 0;
                $av_qty = ($grn_prd->quantity - $grn_prd->set_off);
                if ($av_qty < $data->quantity && $request_qty == 0) {
                    $qty = $av_qty;
                    $request_qty = $data->quantity - $av_qty;
                } else if ($request_qty != 0) {
                    $qty = $request_qty;
                } else {
                    $qty = $data->quantity;
                }

                if ($product_history->save() && $qty > 0) {
                    // $this->addReturnToSetoff($product_history->internal_id, $product_history->external_id, $grn_prd->internal_id, $grn_prd->external_id, $product_history->product_id, $qty, $product_history->store_id, $grn_prd->transaction_id);
                    $product_history_setoff = new ProductHistorySetOffController();
                    $product_history_setoff->saveMaterialIssue($product_history, $data->store_id);
                    if ($request_qty == 0) {
                        break;
                    }
                }
            }*/
        }
    }







    public function getUom($id)
    {
        try {
            $product =  Product::where('product_primary_id', '=', $id)->first();

            $data = [
                "id" => "0",
                "value" => "",
            ];
            if ($product) {
                $uom =  ProductUnit::find($product->uom_id);
                if ($uom) {
                    $data["id"] = $uom->id;
                    $data["value"] = $uom->name;
                }
            }

            $responseBody = $this->responseBody(true, "MiHeaderController", "getUom", $data);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    private function removeProductHistory($header)
    {
        ProductHistory::where([['document_no', '=', '200'], ['internal_id', '=', $header->internal_id]])->delete();
    }

    private function removeProductFromSetoff($header)
    {

        ProductHistorySetoff::where([['document_no', '=', '200'], ['internal_id', '=', $header->internal_id]])->delete();
    }



    public function isApproved($id)
    {
        try {
            $mi_header = MiHeader::find($id);
            if ($mi_header) {
                $responseBody = $this->responseBody(true, "MiHeaderController", "isApproved", $mi_header->status);
            }
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MiHeaderController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
